com.thinkaurelius.titan.core

## Interface TitanGraphQuery<Q extends TitanGraphQuery<Q>>

- All Superinterfaces:
    com.tinkerpop.blueprints.GraphQuery, com.tinkerpop.blueprints.Query
  All Known Implementing Classes:
    GraphCentricQueryBuilder

      public interface TitanGraphQuery<Q extends TitanGraphQuery<Q>>
      extends com.tinkerpop.blueprints.GraphQuery

  Constructs a query against a mixed index to retrieve all elements (either vertices or edges) that match all conditions.

  Finding matching elements efficiently using this query mechanism requires that appropriate index structures have been defined for the keys. See `TitanManagement` for more information on how to define index structures in Titan.
  Since:
    0.3.0
  Author:
    Matthias Broecheler (me@matthiasb.com)

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.tinkerpop.blueprints.Query

      `com.tinkerpop.blueprints.Query.Compare`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `QueryDescription` | `describeForEdges()` Returns a description of this query for edges as a `QueryDescription` object.
    `QueryDescription` | `describeForProperties()` Returns a description of this query for properties as a `QueryDescription` object.
    `QueryDescription` | `describeForVertices()` Returns a description of this query for vertices as a `QueryDescription` object.
    `Iterable<com.tinkerpop.blueprints.Edge>` | `edges()` Returns all edges that match the conditions.
    `Q` | `has(PropertyKey key, TitanPredicate predicate, Object condition)` The returned element must have a property for the given key that matches the condition according to the specified relation
    `Q` | `has(String key)`
    `Q` | `has(String key, Object value)`
    `Q` | `has(String key, com.tinkerpop.blueprints.Predicate predicate, Object condition)` The returned element must have a property for the given key that matches the condition according to the specified relation
    `<T extends Comparable<T>> Q` | `has(String key, T value, com.tinkerpop.blueprints.Query.Compare compare)` Deprecated.
    `Q` | `hasNot(String key)`
    `Q` | `hasNot(String key, Object value)`
    `<T extends Comparable<?>> Q` | `interval(String key, T startValue, T endValue)`
    `Q` | `limit(int max)` Limits the size of the returned result set
    `Q` | `orderBy(PropertyKey key, Order order)` Orders the element results of this query according to their property for the given key in the given order (increasing/decreasing).
    `Q` | `orderBy(String key, Order order)` Orders the element results of this query according to their property for the given key in the given order (increasing/decreasing).
    `Iterable<TitanProperty>` | `properties()` Returns all properties that match the conditions
    `Iterable<com.tinkerpop.blueprints.Vertex>` | `vertices()` Returns all vertices that match the conditions.

- - ### Method Detail

    - #### has

          Q has(String key,
              com.tinkerpop.blueprints.Predicate predicate,
              Object condition)

      The returned element must have a property for the given key that matches the condition according to the specified relation
      Specified by:
        `has` in interface `com.tinkerpop.blueprints.GraphQuery`
      Specified by:
        `has` in interface `com.tinkerpop.blueprints.Query`
      Parameters:
        `key` - Key that identifies the property
        `predicate` - Predicate between property and condition
        `condition` -
      Returns:
        This query

    - #### has

          Q has(PropertyKey key,
              TitanPredicate predicate,
              Object condition)

      The returned element must have a property for the given key that matches the condition according to the specified relation
      Parameters:
        `key` - Key that identifies the property
        `predicate` - Relation between property and condition
        `condition` -
      Returns:
        This query

    - #### has

          Q has(String key)

      Specified by:
        `has` in interface `com.tinkerpop.blueprints.GraphQuery`
      Specified by:
        `has` in interface `com.tinkerpop.blueprints.Query`

    - #### hasNot

          Q hasNot(String key)

      Specified by:
        `hasNot` in interface `com.tinkerpop.blueprints.GraphQuery`
      Specified by:
        `hasNot` in interface `com.tinkerpop.blueprints.Query`

    - #### has

          Q has(String key,
              Object value)

      Specified by:
        `has` in interface `com.tinkerpop.blueprints.GraphQuery`
      Specified by:
        `has` in interface `com.tinkerpop.blueprints.Query`

    - #### hasNot

          Q hasNot(String key,
                 Object value)

      Specified by:
        `hasNot` in interface `com.tinkerpop.blueprints.GraphQuery`
      Specified by:
        `hasNot` in interface `com.tinkerpop.blueprints.Query`

    - #### has

          @Deprecated
          <T extends Comparable<T>> Q has(String key,
                                                   T value,
                                                   com.tinkerpop.blueprints.Query.Compare compare)

      Deprecated.
      Specified by:
        `has` in interface `com.tinkerpop.blueprints.GraphQuery`
      Specified by:
        `has` in interface `com.tinkerpop.blueprints.Query`

    - #### interval

          <T extends Comparable<?>> Q interval(String key,
                                             T startValue,
                                             T endValue)

      Specified by:
        `interval` in interface `com.tinkerpop.blueprints.GraphQuery`
      Specified by:
        `interval` in interface `com.tinkerpop.blueprints.Query`

    - #### limit

          Q limit(int max)

      Limits the size of the returned result set
      Specified by:
        `limit` in interface `com.tinkerpop.blueprints.GraphQuery`
      Specified by:
        `limit` in interface `com.tinkerpop.blueprints.Query`
      Parameters:
        `max` - The maximum number of results to return
      Returns:
        This query

    - #### orderBy

          Q orderBy(String key,
                  Order order)

      Orders the element results of this query according to their property for the given key in the given order (increasing/decreasing).
      Parameters:
        `key` - The key of the properties on which to order
        `order` - the ordering direction
      Returns:

    - #### orderBy

          Q orderBy(PropertyKey key,
                  Order order)

      Orders the element results of this query according to their property for the given key in the given order (increasing/decreasing).
      Parameters:
        `key` - The key of the properties on which to order
        `order` - the ordering direction
      Returns:

    - #### vertices

          Iterable<com.tinkerpop.blueprints.Vertex> vertices()

      Returns all vertices that match the conditions.
      Specified by:
        `vertices` in interface `com.tinkerpop.blueprints.Query`
      Returns:

    - #### edges

          Iterable<com.tinkerpop.blueprints.Edge> edges()

      Returns all edges that match the conditions.
      Specified by:
        `edges` in interface `com.tinkerpop.blueprints.Query`
      Returns:

    - #### properties

          Iterable<TitanProperty> properties()

      Returns all properties that match the conditions
      Returns:

    - #### describeForVertices

          QueryDescription describeForVertices()

      Returns a description of this query for vertices as a `QueryDescription` object. This can be used to inspect the query plan for this query. Note, that calling this method does not actually execute the query but only optimizes it and constructs a query plan.
      Returns:
        A description of this query for vertices

    - #### describeForEdges

          QueryDescription describeForEdges()

      Returns a description of this query for edges as a `QueryDescription` object. This can be used to inspect the query plan for this query. Note, that calling this method does not actually execute the query but only optimizes it and constructs a query plan.
      Returns:
        A description of this query for edges

    - #### describeForProperties

          QueryDescription describeForProperties()

      Returns a description of this query for properties as a `QueryDescription` object. This can be used to inspect the query plan for this query. Note, that calling this method does not actually execute the query but only optimizes it and constructs a query plan.
      Returns:
        A description of this query for properties

Copyright © 2012–2014. All rights reserved.